SESSION:DATE-FORMAT = "mdy".

DEFINE VARIABLE d AS DATE.
DEFINE VARIABLE dt AS DATETIME.
DEFINE VARIABLE dtz AS DATETIME-TZ.

DISPLAY ADD-INTERVAL(NOW, 3000000, "days") FORMAT "999.999.999999 HH:MM:SS.SSS" SKIP
    "null dte:" ADD-INTERVAL(dt,  100, "day") SKIP
     WITH NO-LABELS NO-BOX.

DEFINE VARIABLE db AS CHAR EXTENT 11 FORMAT "x(40)".
FORM db[11] SKIP 
     " 100 ms "  db[1] SKIP 
     "2500 ms "  db[2] SKIP 
     "9000 sec"  db[3] SKIP 
     " 100 min"  db[4] SKIP 
     "  24 H  "  db[5] SKIP
     " 100 H  "  db[6] SKIP 
     "  30 day"  db[7] SKIP 
     "   2 wee"  db[8] SKIP 
     "   3 mon"  db[9] SKIP 
     "   3 yrs"  db[10] SKIP .

SESSION:DATE-FORMAT = "mdy".
d = 01/02/2000. /* 2nd of jan 2000 on MDY format */
DISPLAY SESSION:DATE-FORMAT + " " + STRING(d) @ db[11].
DISPLAY 
    ADD-INTERVAL(d,  100, "millisecond")   @ db[1]
    ADD-INTERVAL(d, 2500, "millisecond")   @ db[2]
    ADD-INTERVAL(d, 9000, "second")        @ db[3]
    ADD-INTERVAL(d,  100, "minutes")       @ db[4]
    ADD-INTERVAL(d,   24, "hours")         @ db[5]
    ADD-INTERVAL(d,  100, "hours")         @ db[6]
    ADD-INTERVAL(d,   30, "days")          @ db[7]
    ADD-INTERVAL(d,    2, "weeks")         @ db[8]
    ADD-INTERVAL(d,    3, "months")        @ db[9]
    ADD-INTERVAL(d,    3, "year")          @ db[10].
PAUSE.

SESSION:DATE-FORMAT = "dmy".
dt = 2000-02-01T10:11:12.123.
DISPLAY SESSION:DATE-FORMAT + " " + STRING(dt) @ db[11].
DISPLAY 
    ADD-INTERVAL(dt,  100, "millisecond")   @ db[1]
    ADD-INTERVAL(dt, 2500, "millisecond")   @ db[2]
    ADD-INTERVAL(dt, 9000, "second")        @ db[3]
    ADD-INTERVAL(dt,  100, "minutes")       @ db[4]
    ADD-INTERVAL(dt,   24, "hours")         @ db[5]
    ADD-INTERVAL(dt,  100, "hours")         @ db[6]
    ADD-INTERVAL(dt,   30, "days")          @ db[7]
    ADD-INTERVAL(dt,    2, "weeks")         @ db[8]
    ADD-INTERVAL(dt,    3, "months")        @ db[9]
    ADD-INTERVAL(dt,    3, "year")          @ db[10].
PAUSE.

SESSION:DATE-FORMAT = "ymd".
dtz = 2000-02-01T10:11:12.123+04:30.
DISPLAY SESSION:DATE-FORMAT + " " + STRING(dtz) @ db[11].
DISPLAY 
    ADD-INTERVAL(dtz,  100, "millisecond")   @ db[1]
    ADD-INTERVAL(dtz, 2500, "millisecond")   @ db[2]
    ADD-INTERVAL(dtz, 9000, "second")        @ db[3]
    ADD-INTERVAL(dtz,  100, "minutes")       @ db[4]
    ADD-INTERVAL(dtz,   24, "hours")         @ db[5]
    ADD-INTERVAL(dtz,  100, "hours")         @ db[6]
    ADD-INTERVAL(dtz,   30, "days")          @ db[7]
    ADD-INTERVAL(dtz,    2, "weeks")         @ db[8]
    ADD-INTERVAL(dtz,    3, "months")        @ db[9]
    ADD-INTERVAL(dtz,    3, "year")          @ db[10].
PAUSE.
