FUNCTION i RETURN DATE:
    RETURN 12/31/2050.
END.

FUNCTION j RETURN DATETIME:
    RETURN 2050-12-31T10:30:21.555.
END.

FUNCTION k RETURN DATETIME-TZ:
    RETURN 2050-12-31T10:30:21.555+03:00.
END.

function i1 return integer: return 0. end.
function i2 return int64:   return 0. end.


display "date        = " i() format "99/99/9999" skip
        "datetime    = " j() skip
        "datetime-tz = " k() skip.

display "date(datetime)       = " DATE(DYNAMIC-FUNCTION("j")) format "99/99/9999" skip
        "date(datetime-tz)    = " DATE(DYNAMIC-FUNCTION("k")) format "99/99/9999" skip
        "datetime(date)       = " DATETIME(DYNAMIC-FUNCTION("i")) skip
        "datetime(datetime-tz)= " DATETIME(DYNAMIC-FUNCTION("k")) SKIP
        "datetime-tz(date)    = " datetime-tz(DYNAMIC-FUNCTION("i")) skip
        "datetime-tz(datetime)= " datetime-tz(DYNAMIC-FUNCTION("j")) skip(1) NO-ERROR.

DISPLAY "int/int64 vs. datetimetz:"
        DYNAMIC-FUNCTION("i1") GT DYNAMIC-FUNCTION("k") 
        DYNAMIC-FUNCTION("k")  GT DYNAMIC-FUNCTION("i1") /* fails at runtime  */ SKIP no-error.

/* MESSAGE 2050-12-31T10:30:21.555 GT 12/31/2050.                    -- not compilable */
/* MESSAGE 2050-12-31T10:30:21.555 GT 2050-12-31T10:30:21.555+03:00. -- not compilable */
/* MESSAGE 2050-12-31T10:30:21.555+03:00 GT 12/31/2050.              -- not compilable */


DISPLAY "date vs. datetime:       "
        DYNAMIC-FUNCTION("i") LT DYNAMIC-FUNCTION("j")
        DYNAMIC-FUNCTION("i") EQ DYNAMIC-FUNCTION("j")
        DYNAMIC-FUNCTION("i") GT DYNAMIC-FUNCTION("j")
        /* prints "Incompatible data types in expression or assignment. (223)" */ SKIP NO-ERROR.

DISPLAY "date vs. DATETIME:       "
        DYNAMIC-FUNCTION("i") LT 2050-12-31T10:30:21.555
        DYNAMIC-FUNCTION("i") EQ 2050-12-31T10:30:21.555
        DYNAMIC-FUNCTION("i") GT 2050-12-31T10:30:21.555 /* prints "yes no no" */ SKIP.

DISPLAY "DATE vs. datetime:       "
        12/31/2050 Lt DYNAMIC-FUNCTION("j")
        12/31/2050 EQ DYNAMIC-FUNCTION("j")
        12/31/2050 GT DYNAMIC-FUNCTION("j") /* prints "no yes no" */ SKIP.

DISPLAY "datetime vs. DATE:       "
        DYNAMIC-FUNCTION("j") LT 12/31/2050
        DYNAMIC-FUNCTION("j") EQ 12/31/2050
        DYNAMIC-FUNCTION("j") GT 12/31/2050 /* prints "no yes no" */ SKIP.

DISPLAY "DATETIME vs. date:       "
        2050-12-31T10:30:21.555 LT DYNAMIC-FUNCTION("i")
        2050-12-31T10:30:21.555 EQ DYNAMIC-FUNCTION("i")
        2050-12-31T10:30:21.555 GT DYNAMIC-FUNCTION("i") /* prints "no no yes" */ SKIP.


DISPLAY "date vs. datetimetz:     "
        DYNAMIC-FUNCTION("i") LT DYNAMIC-FUNCTION("k")
        DYNAMIC-FUNCTION("i") EQ DYNAMIC-FUNCTION("k")
        DYNAMIC-FUNCTION("i") GT DYNAMIC-FUNCTION("k")
        /* prints "Incompatible data types in expression or assignment. (223)" */ SKIP NO-ERROR.

DISPLAY "date vs. DATETIMETZ:     "
        DYNAMIC-FUNCTION("i") LT 2050-12-31T10:30:21.555+03:00
        DYNAMIC-FUNCTION("i") EQ 2050-12-31T10:30:21.555+03:00
        DYNAMIC-FUNCTION("i") GT 2050-12-31T10:30:21.555+03:00 /* prints "yes no no" */ SKIP.

DISPLAY "DATE vs. datetimetz:     "
        12/31/2050 Lt DYNAMIC-FUNCTION("k")
        12/31/2050 EQ DYNAMIC-FUNCTION("k")
        12/31/2050 GT DYNAMIC-FUNCTION("k") /* prints "no  yes no" */ SKIP.

DISPLAY "datetimetz vs. DATE:     "
        DYNAMIC-FUNCTION("k") LT 12/31/2050
        DYNAMIC-FUNCTION("k") EQ 12/31/2050
        DYNAMIC-FUNCTION("k") GT 12/31/2050 /* prints "no  yes no" */ SKIP.

DISPLAY "DATETIMETZ vs. date:     "
        2050-12-31T10:30:21.555+03:00 LT DYNAMIC-FUNCTION("i")
        2050-12-31T10:30:21.555+03:00 EQ DYNAMIC-FUNCTION("i")
        2050-12-31T10:30:21.555+03:00 GT DYNAMIC-FUNCTION("i") /* prints "no no yes" */ SKIP.


DISPLAY "datetimetz vs. datetime: "
        DYNAMIC-FUNCTION("k") LT DYNAMIC-FUNCTION("j")
        DYNAMIC-FUNCTION("k") EQ DYNAMIC-FUNCTION("j")
        DYNAMIC-FUNCTION("k") GT DYNAMIC-FUNCTION("j")
        /* prints "Incompatible data types in expression or assignment. (223)" */ SKIP NO-ERROR.

DISPLAY "datetime vs. datetimetz: "
        DYNAMIC-FUNCTION("j") Lt DYNAMIC-FUNCTION("k")
        DYNAMIC-FUNCTION("j") EQ DYNAMIC-FUNCTION("k")
        DYNAMIC-FUNCTION("j") GT DYNAMIC-FUNCTION("k")
         /* prints "Incompatible data types in expression or assignment. (223)" */ SKIP NO-ERROR.

DISPLAY "datetime vs. DATETIMETZ: "
        DYNAMIC-FUNCTION("j") LT 2050-12-31T10:30:21.555+03:00
        DYNAMIC-FUNCTION("j") EQ 2050-12-31T10:30:21.555+03:00
        DYNAMIC-FUNCTION("j") GT 2050-12-31T10:30:21.555+03:00 /* prints "no  no  yes" */ SKIP.

DISPLAY "DATETIME vs. datetimetz: "
        2050-12-31T10:30:21.555 Lt DYNAMIC-FUNCTION("k")
        2050-12-31T10:30:21.555 EQ DYNAMIC-FUNCTION("k")
        2050-12-31T10:30:21.555 GT DYNAMIC-FUNCTION("k") /* prints "no  no  yes" */ SKIP.

DISPLAY "datetimetz vs. DATETIME: "
        DYNAMIC-FUNCTION("k") LT 2050-12-31T10:30:21.555
        DYNAMIC-FUNCTION("k") EQ 2050-12-31T10:30:21.555
        DYNAMIC-FUNCTION("k") GT 2050-12-31T10:30:21.555 /* prints "yes no no" */ SKIP.

DISPLAY "DATETIMETZ vs. datetime: "
        2050-12-31T10:30:21.555+03:00 LT DYNAMIC-FUNCTION("j")
        2050-12-31T10:30:21.555+03:00 EQ DYNAMIC-FUNCTION("j")
        2050-12-31T10:30:21.555+03:00 GT DYNAMIC-FUNCTION("j") /* prints "yes no no" */ SKIP.


DISPLAY "DATETIME-TZ vs. DATETIME-TZ reloaded:" SKIP
      2050-12-31T10:30:21.555+10:00 GT 2050-12-31T10:30:21.554+10:00
      2050-12-31T10:30:20.555+10:00 LT 2050-12-31T10:30:21.554+10:00
      
      2050-12-31T10:30:21.555+03:00 GT 2050-12-31T10:30:21.555+10:00
      2050-12-31T10:30:21.555+12:00 LT 2050-12-31T10:30:21.554+10:00
      
      2050-12-31T10:30:21.555+10:00 EQ 2050-12-31T12:30:21.555+12:00 /* prints "yes yes yes yes yes" */ SKIP.


/* Expected output:
┌─────────────────────────────────────────────────────┐
│date        =  31/12/2050                            │
│datetime    =  31/12/2050 10:30:21.555               │
│datetime-tz =  31/12/2050 10:30:21.555+03:00         │
│date(datetime)       =  31/12/2050                   │
│date(datetime-tz)    =  31/12/2050                   │
│datetime(date)       =  31/12/2050 00:00:00.000      │
│datetime(datetime-tz)=                               │
│datetime-tz(date)    =  31/12/2050 00:00:00.000+01:00│
│datetime-tz(datetime)=  31/12/2050 10:30:21.555+01:00│
│                                                     │
│int/int64 vs. datetimetz: ?   ?                      │
│date vs. datetime:        ?   ?   ?                  │ -- unknown cast at compile time
│date vs. DATETIME:        yes no  no                 │ -- cast date to datetime with time = 00:00
│DATE vs. datetime:        no  yes no                 │ -- cast datetime to date losing time
│datetime vs. DATE:        no  yes no                 │ -- cast datetime to date losing time
│DATETIME vs. date:        no  no  yes                │ -- cast date to datetime with time = 00:00
│date vs. datetimetz:      ?   ?   ?                  │ -- unknown conversion at compile time
│date vs. DATETIMETZ:      yes no  no                 │ -- cast date to datetimetz with time = 00:00+localTimeZone
│DATE vs. datetimetz:      no  yes no                 │ -- cast datetime to date losing time and timezone
│datetimetz vs. DATE:      no  yes no                 │ -- cast datetime to date losing time and timezone
│DATETIMETZ vs. date:      no  no  yes                │ -- cast date to datetimetz with time = 00:00+localTimeZone
│datetimetz vs. datetime:  ?   ?   ?                  │ -- unknown conversion at compile time
│datetime vs. datetimetz:  ?   ?   ?                  │ -- unknown conversion at compile time
│datetime vs. DATETIMETZ:  no  no  yes                │ -- datetime is always greater ?
│DATETIME vs. datetimetz:  no  no  yes                │
│datetimetz vs. DATETIME:  yes no  no                 │ --- datetimetz always lower ?
│DATETIMETZ vs. datetime:  yes no  no                 │
│DATETIME-TZ vs. DATETIME-TZ reloaded:                │
│yes yes yes yes yes                                  │
└─────────────────────────────────────────────────────┘
*/







