/* this code tests date(time-tz) parsing of a string */ 

SESSION:DATE-FORMAT="ymd".

DEF VAR d AS DATE.
DEF VAR dt AS DATETIME.
DEF VAR dtz AS DATETIME-TZ.

d = 12/05/31.
dt = 12/05/31.
dtz = 12/05/31.
DISPLAY d SKIP dt SKIP dtz WITH SIDE-LABELS.
PAUSE.

d = date("2013-05-31T18:30"). 
dt = datetime("2013-05-31T18:30").
dtz = datetime-tz("2013-05-31T18:30").
DISPLAY d SKIP dt SKIP dtz WITH SIDE-LABELS.
PAUSE.

d = date("2013-05-31T18:30:59").
dt = datetime("2013-05-31T18:30:59").
dtz = datetime-tz("2013-05-31T18:30:59").
DISPLAY d SKIP dt SKIP dtz WITH SIDE-LABELS.
PAUSE.

d = date("2013-05-31T18:30:59.999").
dt = datetime("2013-05-31T18:30:59.999").
dtz = datetime-tz("2013-05-31T18:30:59.999").
DISPLAY d SKIP dt SKIP dtz WITH SIDE-LABELS.
PAUSE.

d = date("2013-05-31T18:30:59.999-05:30").
dt = datetime("2013-05-31T18:30:59.999-05:30").
dtz = datetime-tz("2013-05-31T18:30:59.999-05:30").
DISPLAY d SKIP dt SKIP dtz WITH SIDE-LABELS.
