DEFINE STREAM toFile.
OUTPUT STREAM toFile TO "datetime-routine-tests.txt".

DEFINE VARIABLE cnt AS INTEGER INIT 0.

function afun return logical
   (input d as DATE,
    input dt as datetime,
    input dtz as datetime-tz):
   
   cnt = cnt + 1.
   DISPLAY STREAM toFile 
      cnt + 0 SKIP 
      d  + 0 SKIP 
      dt  + 0 SKIP 
      dtz  + 0 SKIP 
      "afun" SKIP 
      WITH FRAME f SIDE-LABEL.
   return true.
end.

function bfn2 return logical
   (OUTPUT d as date,
    OUTPUT dt as datetime,
    OUTPUT dtz as datetime-tz):
   
   cnt = cnt + 1.
   DISPLAY STREAM toFile 
      cnt + 0 SKIP 
      d  + 0 SKIP 
      dt  + 0 SKIP 
      dtz  + 0 SKIP 
      "bfn2" SKIP 
      WITH FRAME f SIDE-LABEL.
   return true.
end.

function cfnc3 return logical
   (INPUT-OUTPUT d as date,
    INPUT-OUTPUT dt as datetime,
    INPUT-OUTPUT dtz as datetime-tz):
   
   cnt = cnt + 1.
   DISPLAY STREAM toFile 
      cnt + 0 SKIP 
      d  + 0 SKIP 
      dt  + 0 SKIP 
      dtz  + 0 SKIP 
      "cfnc3" SKIP 
      WITH FRAME f SIDE-LABEL.
   return true.
end.

function getDate return date () : return today. end.
function getDatetime return datetime (): return now. end.
function getDatetime-tz return datetime-tz (): return now. end.

procedure p1:
   define input parameter d as DATE.
   define input parameter dt as datetime.
   define input parameter dtz as datetime-tz.

   cnt = cnt + 1.
   DISPLAY STREAM toFile 
      cnt + 0 SKIP 
      d  + 0  FORMAT "99/99/9999" SKIP 
      dt  + 0 SKIP 
      dtz  + 0 SKIP 
      "p1" SKIP 
      WITH FRAME f SIDE-LABEL.
end.

procedure p2:
   define OUTPUT parameter d as date.
   define OUTPUT parameter dt as datetime.
   define OUTPUT parameter dtz as datetime-tz.

   cnt = cnt + 1.
   DISPLAY STREAM toFile 
      cnt + 0 SKIP 
      d  + 0 SKIP 
      dt  + 0 SKIP 
      dtz  + 0 SKIP 
      "p2" SKIP 
      WITH FRAME f SIDE-LABEL.
end.

procedure p3:
   define INPUT-OUTPUT parameter d as date.
   define INPUT-OUTPUT parameter dt as datetime.
   define INPUT-OUTPUT parameter dtz as datetime-tz.

   cnt = cnt + 1.
   DISPLAY STREAM toFile 
      cnt + 0 SKIP 
      d  + 0 SKIP 
      dt  + 0 SKIP 
      dtz  + 0 SKIP 
      "p3" SKIP 
      WITH FRAME f SIDE-LABEL.
end.

define variable d as date.
define variable dt as datetime.
define variable dtz as datetime-tz.

d   = 12/31/1999.
dt  = 1907-03-01T08:07:06.543.
dtz = 2234-11-15T22:33:44.555+05:30.

/* input mode parameters */
afun(d, d, d).
afun(getDate(), getDate(), getDate()).
afun(d, d, dt).
afun(getDate(), getDate(), getDatetime()).
afun(d, d, dtz).
afun(getDate(), getDate(), getDatetime-tz()).
afun(d, dt, d).
afun(getDate(), getDatetime(), getDate()).
afun(d, dt, dt).
afun(getDate(), getDatetime(), getDatetime()).
afun(d, dt, dtz).
afun(getDate(), getDatetime(), getDatetime-tz()).
/*afun(d, dtz, d).*/
/*afun(d, dtz, dt).*/
/*afun(d, dtz, dtz).*/
/*afun(dt, d, d).*/
/*afun(dt, d, dt).*/
/*afun(dt, d, dtz).*/
/*afun(dt, dt, d).*/
/*afun(dt, dt, dt).*/
/*afun(dt, dt, dtz).*/
/*afun(dt, dtz, d).*/
/*afun(dt, dtz, dt).*/
/*afun(dt, dtz, dtz).*/
/*afun(dtz, d, d).*/
/*afun(dtz, d, dt).*/
/*afun(dtz, d, dtz).*/
/*afun(dtz, dt, d).*/
/*afun(dtz, dt, dt).*/
/*afun(dtz, dt, dtz).*/
/*afun(dtz, dtz, d).*/
/*afun(dtz, dtz, dt).*/
/*afun(dtz, dtz, dtz).*/

/*afun(NOW, NOW, NOW).*/
/*afun(NOW, NOW, TODAY).*/
/*afun(NOW, TODAY, NOW).*/
/*afun(NOW, TODAY, TODAY).*/
/*afun(TODAY, NOW, NOW).*/
/*afun(TODAY, NOW, TODAY).*/
afun(TODAY, TODAY, NOW).
afun(TODAY, TODAY, TODAY).

run p1(d, d, d).
run p1(d, d, dt).
run p1(d, d, dtz).
run p1(d, dt, d).
run p1(d, dt, dt).
run p1(d, dt, dtz).
run p1(d, dtz, d).
run p1(d, dtz, dt).
run p1(d, dtz, dtz).
run p1(dt, d, d).
run p1(dt, d, dt).
run p1(dt, d, dtz).
run p1(dt, dt, d).
run p1(dt, dt, dt).
run p1(dt, dt, dtz).
run p1(dt, dtz, d).
run p1(dt, dtz, dt).
run p1(dt, dtz, dtz).
run p1(dtz, d, d).
run p1(dtz, d, dt).
run p1(dtz, d, dtz).
run p1(dtz, dt, d).
run p1(dtz, dt, dt).
run p1(dtz, dt, dtz).
run p1(dtz, dtz, d).
run p1(dtz, dtz, dt).
run p1(dtz, dtz, dtz).


/* mode parameters */
/*bfn2(d, d, d).*/
/*bfn2(d, d, dt).*/
/*bfn2(d, d, dtz).*/
/*bfn2(d, dt, d).*/
/*bfn2(d, dt, dt).*/
bfn2(d, dt, dtz).
/*bfn2(d, dtz, d).*/
/*bfn2(d, dtz, dt).*/
bfn2(d, dtz, dtz).
/*bfn2(dt, d, d).*/
/*bfn2(dt, d, dt).*/
/*bfn2(dt, d, dtz).*/
/*bfn2(dt, dt, d).*/
/*bfn2(dt, dt, dt).*/
bfn2(dt, dt, dtz).
/*bfn2(dt, dtz, d).*/
/*bfn2(dt, dtz, dt).*/
bfn2(dt, dtz, dtz).
/*bfn2(dtz, d, d).*/
/*bfn2(dtz, d, dt).*/
/*bfn2(dtz, d, dtz).*/
/*bfn2(dtz, dt, d).*/
/*bfn2(dtz, dt, dt).*/
bfn2(dtz, dt, dtz). 
/*bfn2(dtz, dtz, d).*/
/*bfn2(dtz, dtz, dt).*/
bfn2(dtz, dtz, dtz). 

run p2(OUTPUT d, OUTPUT d, OUTPUT d).
run p2(OUTPUT d, OUTPUT d, OUTPUT dt).
run p2(OUTPUT d, OUTPUT d, OUTPUT dtz).
run p2(OUTPUT d, OUTPUT dt, OUTPUT d).
run p2(OUTPUT d, OUTPUT dt, OUTPUT dt).
run p2(OUTPUT d, OUTPUT dt, OUTPUT dtz).
run p2(OUTPUT d, OUTPUT dtz, OUTPUT d).
run p2(OUTPUT d, OUTPUT dtz, OUTPUT dt).
run p2(OUTPUT d, OUTPUT dtz, OUTPUT dtz).
run p2(OUTPUT dt, OUTPUT d, OUTPUT d).
run p2(OUTPUT dt, OUTPUT d, OUTPUT dt).
run p2(OUTPUT dt, OUTPUT d, OUTPUT dtz).
run p2(OUTPUT dt, OUTPUT dt, OUTPUT d).
run p2(OUTPUT dt, OUTPUT dt, OUTPUT dt).
run p2(OUTPUT dt, OUTPUT dt, OUTPUT dtz).
run p2(OUTPUT dt, OUTPUT dtz, OUTPUT d).
run p2(OUTPUT dt, OUTPUT dtz, OUTPUT dt).
run p2(OUTPUT dt, OUTPUT dtz, OUTPUT dtz).
run p2(OUTPUT dtz, OUTPUT d, OUTPUT d).
run p2(OUTPUT dtz, OUTPUT d, OUTPUT dt).
run p2(OUTPUT dtz, OUTPUT d, OUTPUT dtz).
run p2(OUTPUT dtz, OUTPUT dt, OUTPUT d).
run p2(OUTPUT dtz, OUTPUT dt, OUTPUT dt).
run p2(OUTPUT dtz, OUTPUT dt, OUTPUT dtz).
run p2(OUTPUT dtz, OUTPUT dtz, OUTPUT d).
run p2(OUTPUT dtz, OUTPUT dtz, OUTPUT dt).
run p2(OUTPUT dtz, OUTPUT dtz, OUTPUT dtz).


/* input-mode parameters */
/*cfnc3(d, d, d).*/
/*cfnc3(d, d, dt).*/
/*cfnc3(d, d, dtz).*/
/*cfnc3(d, dt, d).*/
/*cfnc3(d, dt, dt).*/
cfnc3(d, dt, dtz).
/*cfnc3(d, dtz, d).*/
/*cfnc3(d, dtz, dt).*/
/*cfnc3(d, dtz, dtz).*/
/*cfnc3(dt, d, d).*/
/*cfnc3(dt, d, dt).*/
/*cfnc3(dt, d, dtz).*/
/*cfnc3(dt, dt, d).*/
/*cfnc3(dt, dt, dt).*/
/*cfnc3(dt, dt, dtz).*/
/*cfnc3(dt, dtz, d).*/
/*cfnc3(dt, dtz, dt).*/
/*cfnc3(dt, dtz, dtz).*/
/*cfnc3(dtz, d, d).*/
/*cfnc3(dtz, d, dt).*/
/*cfnc3(dtz, d, dtz).*/
/*cfnc3(dtz, dt, d).*/
/*cfnc3(dtz, dt, dt).*/
/*cfnc3(dtz, dt, dtz).*/
/*cfnc3(dtz, dtz, d).*/
/*cfnc3(dtz, dtz, dt).*/
/*cfnc3(dtz, dtz, dtz).*/

run p3(INPUT-OUTPUT d, INPUT-OUTPUT d, INPUT-OUTPUT d).
run p3(INPUT-OUTPUT d, INPUT-OUTPUT d, INPUT-OUTPUT dt).
run p3(INPUT-OUTPUT d, INPUT-OUTPUT d, INPUT-OUTPUT dtz).
run p3(INPUT-OUTPUT d, INPUT-OUTPUT dt, INPUT-OUTPUT d).
run p3(INPUT-OUTPUT d, INPUT-OUTPUT dt, INPUT-OUTPUT dt).
run p3(INPUT-OUTPUT d, INPUT-OUTPUT dt, INPUT-OUTPUT dtz).
run p3(INPUT-OUTPUT d, INPUT-OUTPUT dtz, INPUT-OUTPUT d).
run p3(INPUT-OUTPUT d, INPUT-OUTPUT dtz, INPUT-OUTPUT dt).
run p3(INPUT-OUTPUT d, INPUT-OUTPUT dtz, INPUT-OUTPUT dtz).
run p3(INPUT-OUTPUT dt, INPUT-OUTPUT d, INPUT-OUTPUT d).
run p3(INPUT-OUTPUT dt, INPUT-OUTPUT d, INPUT-OUTPUT dt).
run p3(INPUT-OUTPUT dt, INPUT-OUTPUT d, INPUT-OUTPUT dtz).
run p3(INPUT-OUTPUT dt, INPUT-OUTPUT dt, INPUT-OUTPUT d).
run p3(INPUT-OUTPUT dt, INPUT-OUTPUT dt, INPUT-OUTPUT dt).
run p3(INPUT-OUTPUT dt, INPUT-OUTPUT dt, INPUT-OUTPUT dtz).
run p3(INPUT-OUTPUT dt, INPUT-OUTPUT dtz, INPUT-OUTPUT d).
run p3(INPUT-OUTPUT dt, INPUT-OUTPUT dtz, INPUT-OUTPUT dt).
run p3(INPUT-OUTPUT dt, INPUT-OUTPUT dtz, INPUT-OUTPUT dtz).
run p3(INPUT-OUTPUT dtz, INPUT-OUTPUT d, INPUT-OUTPUT d).
run p3(INPUT-OUTPUT dtz, INPUT-OUTPUT d, INPUT-OUTPUT dt).
run p3(INPUT-OUTPUT dtz, INPUT-OUTPUT d, INPUT-OUTPUT dtz).
run p3(INPUT-OUTPUT dtz, INPUT-OUTPUT dt, INPUT-OUTPUT d).
run p3(INPUT-OUTPUT dtz, INPUT-OUTPUT dt, INPUT-OUTPUT dt).
run p3(INPUT-OUTPUT dtz, INPUT-OUTPUT dt, INPUT-OUTPUT dtz).
run p3(INPUT-OUTPUT dtz, INPUT-OUTPUT dtz, INPUT-OUTPUT d).
run p3(INPUT-OUTPUT dtz, INPUT-OUTPUT dtz, INPUT-OUTPUT dt).
run p3(INPUT-OUTPUT dtz, INPUT-OUTPUT dtz, INPUT-OUTPUT dtz).

MESSAGE "ok".
