DEFINE VARIABLE LdaInputDate AS DATE        NO-UNDO.
DEFINE VARIABLE LiInputTime  AS INTEGER     NO-UNDO.
DEFINE VARIABLE LdatzInputDateTimeTZ AS DATETIME-TZ NO-UNDO.

ASSIGN  LdaInputDate = TODAY
        LiInputTime = MTIME.

LdatzInputDateTimeTZ = DATETIME(LdaInputDate,LiInputTime).

MESSAGE 'current datetime ' ISO-DATE(LdatzInputDateTimeTZ) ' current timezone ' string(TIMEZONE,'+hh:mm') VIEW-AS ALERT-BOX.


/* { datetime/datetime-in-temp-tables.p } */ 
/* { datetime/datetime-in-psql-table.p } */
/* new FindQuery(dtt, "dtt.d != toDate('15-06-74')", null, "dtt.d asc, dtt.dt asc, dtt.dtz asc").first(); */


/*
DISPLAY 2001-06-30T23:59:59.999+05:00 GT 2001-06-30T23:59:59.999+06:00.
QUIT.


DISPLAY SESSION:TIME-SOURCE SKIP.
SESSION:TIME-SOURCE = "localhost".
DISPLAY SESSION:TIME-SOURCE SKIP(2).

MESSAGE DATETIME-TZ(TODAY, MTIME, TIMEZONE) NOW.
MESSAGE DATETIME(TODAY, MTIME).

session:date-format="mdy".

DEF VAR dtz AS DATETIME-TZ INIT 2013-05-22t10:10:10+03.
DEF VAR dt AS DATETIME.

DISPLAY dtz + 0 SKIP.
dt = dtz.
DISPLAY dt + 0 SKIP .
dtz = dt.
DISPLAY dtz + 0 SKIP.
dt = dtz.
DISPLAY dt + 0 SKIP(1) .

dtz = 2013-12-22t10:10:10+03.
DISPLAY dtz + 0 SKIP.
dt = dtz.
DISPLAY dt + 0 SKIP .
dtz = dt.
DISPLAY dtz + 0 SKIP.
dt = dtz.
DISPLAY dt + 0 SKIP(1) .
   
dtz = now.
DISPLAY dtz + 0 SKIP.
dt = dtz.
DISPLAY dt + 0 SKIP .
dtz = dt.
DISPLAY dtz + 0 SKIP.
dt = dtz.
DISPLAY dt + 0 SKIP(1).


DISPLAY "DATETIME(06/10/2013 10:20:30 +04:00)" DATETIME("06/10/2013 10:20:30 +04:00") skip
        "DATETIME(12/10/2013 10:20:30 +04:00)" DATETIME("12/10/2013 10:20:30 +04:00").
*/

/* display now. */

/* { datetime/compare-date-time-tz.p } */

/* {datetime/datetime-routine-tests.p} */
/* {datetime/datetime-routine-tests2.p} */

/* { datetime/date-time-tz-interval-tests-to-file.p } */

/* { datetime/date-time-tz-literals.and.inits.p } */

/* assignment of datetime-tz to datetime (tz is automatically shifted to GMT, 00:00)

DEFINE VARIABLE d1 AS DATETIME-TZ.
DEFINE VARIABLE d2 AS DATETIME.
d1 = 2013-12-12T12:10:10.100+12:00.
d2 = 2013-12-12T12:10:10.100-12:00.

DISPLAY INTERVAL(d1, d2, "minute") SKIP MTIME(d1) MTIME(d2) SKIP.
DISPLAY d1 SKIP d2 SKIP WITH NO-LABELS.
DISPLAY DATE(d1) DATE(d2). 
*/ 

/* This code shows a peculiar behavior of Progress when year cannot be represented on 4 digits: 
DISPLAY SKIP ISO-DATE(DATETIME-TZ(DATE(0), MTIME, TIMEZONE)) FORMAT "x(40)".
*/

/*
DEFINE VARIABLE s AS CHAR INIT "12/12/2012 10:21+10:30".
DEFINE VAR dd AS DATE INIT 12/12/12.
DEFINE VAR d1 AS DATEtime INIT 2000-12-12T10:10.
DEFINE VAR d2 AS DATEtime INIT 2000-12-12T10:10-10:10.
DEFINE VAR k1 AS DATETIME-TZ INIT 2000-12-12T10:10.
DEFINE VAR k2 AS DATETIME-TZ INIT 2000-12-12T10:10-10:10.

DISPLAY dd SKIP d1 SKIP d2 SKIP k1 SKIP k2 SKIP(2) WITH SIDE-LABELS.

DEFINE VARIABLE s AS CHAR INIT "12/12/2012 10:21+10:30".
DISPLAY DATE(s) SKIP .
DISPLAY DATETIME(s) 1988-10-10T10:10 SKIP .
DISPLAY DATETIME-TZ(s) SKIP.

MESSAGE timezone(2050-12-31T10:30:21.555+00).
MESSAGE timezone(DATETIME-TZ(2050-12-31T10:30:21.555)).

DISPLAY INTERVAL(DATETIME-TZ(2050-12-31T10:30:21.555), 
                 2050-12-31T10:30:21.555+10:00, "minutes").*/



/* This code shows that parsing literals is different from parsing string representations of date 
SESSION:DATE-FORMAT = "dmy".
MESSAGE DATE("04/05/-4716") EQ 04/05/-4716. /* should be NO */ 
*/

/* { datetime/date-time-tz-interval-tests.p } */
/* { datetime/datetimetz-add-interval-edge-tests.p } */
/* { datetime/datetime-add-interval-edge-tests.p } */
/* { datetime/add-interval-edge-tests.p } */

/*
SESSION:DATE-FORMAT = "Ymd".

DEFINE VARIABLE ref AS CHARACTER.
FORM ">" ref "<" WITH NO-LABELS.

DEFINE VARIABLE d AS DATETIME /* FORMAT "99-9999-99" */.
D = NOW.

DISPLAY d @ ref.
*/



/* de investigat:
SESSION:DATE-FORMAT = "mdy".

DEFINE VARIABLE d AS DATE.
DEFINE VARIABLE dt AS DATETIME.
DEFINE VARIABLE dtz AS DATETIME-TZ.

d = DATE("07-22-2013 23:45:30.123+01:30").
dt = DATETIME("07-22-2013 23:45:30.123+01:30").
dtz = DATETIME-TZ("07-22-2013 23:45:30.123+01:30").
MESSAGE d dt dtz.

d = DATE("07-22-2013 23:45:30.123-01:30").
dt = DATETIME("07-22-2013 23:45:30.123-01:30").
dtz = DATETIME-TZ("07-22-2013 23:45:30.123-01:30").
MESSAGE d dt dtz.

/* expected output:
  07/22/13   07/22/2013 23:15:30.123   07/22/2013 23:45:30.123+01:30
  07/22/13   07/23/2013 02:15:30.123   07/22/2013 23:45:30.123-01:30
*/
*/






/*
SESSION:DATE-FORMAT = "mdy".
DISPLAY SESSION:DATE-FORMAT SKIP .
DISPLAY DATETIME(TODAY, 2147483647) SKIP .
DISPLAY DATETIME(TODAY, 2147483648) SKIP .
DISPLAY DATETIME(TODAY, 2147483649) SKIP .

DISPLAY DATETIME(TODAY,  12 * 60 *60 * 1000) SKIP .
DISPLAY DATETIME(TODAY, -12 * 60 *60 * 1000) SKIP . */







/* { datetime/compare-date-time-tz.p} */

/* {datetime/add-interval.p} */

/* {datetime/datetime-test1.p} */

/* {datetime/datetime-test2.p} */

pause "ok?".
quit.
