/* datetime-tz display format test */
DEFINE VARIABLE dtz AS DATETIME-TZ.
dtz = DATETIME-TZ(4, 27, 2013, 15, 20, 30, 456, -90).

MESSAGE dtz FORMAT "99-99-9999thh:mm:ss.s aM+hh:mm" NOW.
DISPLAY dtz + 0 FORMAT "99-99-99"
        dtz + 0 FORMAT "99-99-9999"
        dtz + 0 FORMAT "99-9999-99"
        dtz + 0 FORMAT "9999-99-99" SKIP .                /* 27-04-13 27-04-2013 27-04-2013 27-04-2013 */
DISPLAY dtz + 0 FORMAT "99-99-9999 h:MM" SKIP.            /* 27-04-2013 05MM */
DISPLAY dtz + 0 FORMAT "99-99-9999 h:MM A" SKIP.          /* 27-04-2013  5MM A */
DISPLAY dtz + 0 FORMAT "99-99-9999Thh:MM AM-HH:" SKIP.    /* 27-04-2013T 5:20 AM+01: */
DISPLAY dtz + 0 FORMAT "99-99-9999Thh:MM AM-HH:MM" SKIP.  /* 27-04-2013T 5:20 AM+01:00 */
DISPLAY dtz + 0 FORMAT "99-99-9999Thh:MM AM-H:MM" SKIP.   /* 27-04-2013T 5:20 AM+01MM */
DISPLAY dtz + 0 FORMAT "99-99-9999    H    aM-H:MM" SKIP. /* 27-04-2013     5   aM+01MM */
DISPLAY dtz + 0 FORMAT "99-99-9999    H    aM-H" SKIP.    /* 27-04-2013     5   aM+0 */
DISPLAY dtz + 0 FORMAT "99-99-9999    H    aM-" SKIP.     /* 27-04-2013     5   aM- */
 



/* datetime display format test */
DEFINE VARIABLE dt AS DATETIME.
dt = DATETIME(4, 27, 2013, 15, 20, 30, 456).

DISPLAY dt + 0 FORMAT "99-99-99"
        dt + 0 FORMAT "99-99-9999"
        dt + 0 FORMAT "99-9999-99"
        dt + 0 FORMAT "9999-99-99" SKIP .                /* 27-04-13 27-04-2013 27-04-2013 27-04-2013 */
DISPLAY dt + 0 FORMAT "99-99-9999 h:MM" SKIP.            /* 27-04-2013 05MM */
DISPLAY dt + 0 FORMAT "99-99-9999 h:MM A" SKIP.          /* 27-04-2013  5MM A */
DISPLAY dt + 0 FORMAT "99-99-9999Thh:MM AM-HH:" SKIP.    /* 27-04-2013T 5:20 AM+01: */
DISPLAY dt + 0 FORMAT "99-99-9999Thh:MM AM-HH:MM" SKIP.  /* 27-04-2013T 5:20 AM+01:00 */
DISPLAY dt + 0 FORMAT "99-99-9999Thh:MM AM-H:MM" SKIP.   /* 27-04-2013T 5:20 AM+01MM */
DISPLAY dt + 0 FORMAT "99-99-9999    H    aM-H:MM" SKIP. /* 27-04-2013     5   aM+01MM */
DISPLAY dt + 0 FORMAT "99-99-9999    H    aM-H" SKIP.    /* 27-04-2013     5   aM+0 */
DISPLAY dt + 0 FORMAT "99-99-9999    H    aM-" SKIP.     /* 27-04-2013     5   aM- */
