define temp-table tt1
   field i as integer
   field ii as integer extent 2
   field j as int64
   field jj as int64 extent 2
   field d as decimal
   field dd as decimal extent 2
   field z as date.
    
create tt1.
assign
   i = 1
   ii[1] =  2000000000
   ii[2] = -2000000000
   j = 1
   jj[1] =  4000000000
   jj[2] = -4000000000
   d = 3.14
   dd[1] =  2000.111
   dd[2] = -2000.111
   z = today.
   
/* create tt1.
assign
   i = 1
   ii[1] =  2000000000
   ii[2] = -2000000000
   j = 1
   jj[1] =  4000000001
   jj[2] = -4000000000
   d = 3.14
   dd[1] =  2000.111
   dd[2] = -2000.111
   z = today. */
   

find tt1 where i + 1 ne j - 1 no-error.
find tt1 where i + 1 ne d - 1 no-error.
find tt1 where j + 1 ne i - 1 no-error.
find tt1 where j + 1 ne j - 1 no-error.
find tt1 where j + 1 ne d - 1 no-error.
find tt1 where d + 1 ne i - 1 no-error.
find tt1 where d + 1 ne j - 1 no-error.
find tt1 where d + 1 ne d - 1 no-error.

find tt1 where i eq j no-error.
find tt1 where i eq d no-error.
find tt1 where j eq i no-error.
find tt1 where j eq j no-error.
find tt1 where j eq d no-error.
find tt1 where d eq i no-error.
find tt1 where d eq j no-error.
find tt1 where d eq d no-error.

find tt1 where i gt j no-error.
find tt1 where i gt d no-error.
find tt1 where j gt i no-error.
find tt1 where j gt j no-error.
find tt1 where j gt d no-error.
find tt1 where d gt i no-error.
find tt1 where d gt j no-error.
find tt1 where d gt d no-error.

find tt1 where i lt j no-error.
find tt1 where i lt d no-error.
find tt1 where j lt i no-error.
find tt1 where j lt j no-error.
find tt1 where j lt d no-error.
find tt1 where d lt i no-error.
find tt1 where d lt j no-error.
find tt1 where d lt d no-error.

find tt1 where i <= j no-error.
find tt1 where i <= d no-error.
find tt1 where j <= i no-error.
find tt1 where j <= j no-error.
find tt1 where j <= d no-error.
find tt1 where d <= i no-error.
find tt1 where d <= j no-error.
find tt1 where d <= d no-error.

find tt1 where i >= j no-error.
find tt1 where i >= d no-error.
find tt1 where j >= i no-error.
find tt1 where j >= j no-error.
find tt1 where j >= d no-error.
find tt1 where d >= i no-error.
find tt1 where d >= j no-error.
find tt1 where d >= d no-error.

find tt1 where i + j = 0 no-error.
find tt1 where i + d = 0 no-error.
find tt1 where j + i = 0 no-error.
find tt1 where j + j = 0 no-error.
find tt1 where j + d = 0 no-error.
find tt1 where d + i = 0 no-error.
find tt1 where d + j = 0 no-error.
find tt1 where d + d = 0 no-error.

find tt1 where i - j = 0 no-error.
find tt1 where i - d = 0 no-error.
find tt1 where j - i = 0 no-error.
find tt1 where j - j = 0 no-error.
find tt1 where j - d = 0 no-error.
find tt1 where d - i = 0 no-error.
find tt1 where d - j = 0 no-error.
find tt1 where d - d = 0 no-error.

find tt1 where i * j = 0 no-error.
find tt1 where i * d = 0 no-error.
find tt1 where j * i = 0 no-error.
find tt1 where j * j = 0 no-error.
find tt1 where j * d = 0 no-error.
find tt1 where d * i = 0 no-error.
find tt1 where d * j = 0 no-error.
find tt1 where d * d = 0 no-error.

find tt1 where i / j = 0 no-error.
find tt1 where i / d = 0 no-error.
find tt1 where j / i = 0 no-error.
find tt1 where j / j = 0 no-error.
find tt1 where j / d = 0 no-error.
find tt1 where d / i = 0 no-error.
find tt1 where d / j = 0 no-error.
find tt1 where d / d = 0 no-error.

find tt1 where ii[i + i] = 0 no-error.
find tt1 where ii[j + j] = 0 no-error.
find tt1 where jj[i + i] = 0 no-error.
find tt1 where jj[i + i] = 0 no-error.

find tt1 where i mod j = 0 no-error.
find tt1 where i mod d = 0 no-error.
find tt1 where j mod i = 0 no-error.
find tt1 where j mod j = 0 no-error.
find tt1 where j mod d = 0 no-error.
find tt1 where d mod i = 0 no-error.
find tt1 where d mod j = 0 no-error.
find tt1 where d mod d = 0 no-error.

find tt1 where max(i, j) = 0 no-error.
find tt1 where max(i, d) = 0 no-error.
find tt1 where max(j, i) = 0 no-error.
find tt1 where max(j, j) = 0 no-error.
find tt1 where max(j, d) = 0 no-error.
find tt1 where max(d, i) = 0 no-error.
find tt1 where max(d, j) = 0 no-error.
find tt1 where max(d, d) = 0 no-error.

find tt1 where min(i, j) = 0 no-error.
find tt1 where min(i, d) = 0 no-error.
find tt1 where min(j, i) = 0 no-error.
find tt1 where min(j, j) = 0 no-error.
find tt1 where min(j, d) = 0 no-error.
find tt1 where min(d, i) = 0 no-error.
find tt1 where min(d, j) = 0 no-error.
find tt1 where min(d, d) = 0 no-error.

find tt1 where date(i, i, i) = today no-error.
find tt1 where date(i, i, j) = today no-error.
find tt1 where date(i, j, i) = today no-error.
find tt1 where date(i, j, j) = today no-error.
find tt1 where date(j, i, i) = today no-error.
find tt1 where date(j, i, j) = today no-error.
find tt1 where date(j, j, i) = today no-error.
find tt1 where date(j, j, j) = today no-error.

find tt1 where date(i) = today no-error.
find tt1 where date(j) = today no-error.
/* find tt1 where date(d) = today no-error. -- not compilable */

find tt1 where string(i) = "0" no-error.
find tt1 where string(j) = "0" no-error.
find tt1 where string(d) = "0" no-error.

find tt1 where integer(i) = 0 no-error.
find tt1 where integer(j) = 0 no-error.
find tt1 where integer(d) = 0 no-error.

find tt1 where int64(i) = 0 no-error.
find tt1 where int64(j) = 0 no-error.
find tt1 where int64(d) = 0 no-error.

find tt1 where decimal(i) = 0 no-error.
find tt1 where decimal(j) = 0 no-error.
find tt1 where decimal(d) = 0 no-error.



find tt1 where ii[1] * 2 = jj[1].
/* find first tt1 where i = 1. -- OK */
/* find first tt1 where year(z) > i. --OK */
display tt1 with side-labels.