/* datetime-tz tests */

DEFINE VARIABLE dtz1 AS DATETIME-TZ.
SESSION:DATE-FORMAT = "DMY".

SESSION:TIMEZONE = ?.
dtz1 = NOW.
DISPLAY "tz = local  : " SKIP
        TODAY dtz1 + 0 dtz1 - NOW MTIME SKIP.

SESSION:TIMEZONE = -840.
dtz1 = NOW.
DISPLAY "tz = " SESSION:TIMEZONE " : " SKIP 
        TODAY dtz1 + 0 dtz1 - NOW MTIME SKIP.

SESSION:TIMEZONE = 0.
dtz1 = NOW.
DISPLAY "tz = " SESSION:TIMEZONE " : " SKIP
        TODAY dtz1 + 0 dtz1 - NOW MTIME SKIP.

SESSION:TIMEZONE = +840.
dtz1 = NOW.
DISPLAY "tz = " SESSION:TIMEZONE " : " SKIP
        TODAY dtz1 + 0 dtz1 - NOW MTIME SKIP.


/* expected output:
┌────────────────────────────────────────────────────────────┐
│tz = local  :                                               │
│28/05/13 28/05/2013 14:02:44.188+01:00          0 50,564,188│
│tz =        -840  :                                         │
│27/05/13 27/05/2013 23:02:44.190-14:00         -1 82,964,191│
│tz =           0  :                                         │
│28/05/13 28/05/2013 13:02:44.191+00:00          0 46,964,191│
│tz =         840  :                                         │
│29/05/13 29/05/2013 03:02:44.192+14:00          0 10,964,192│
└────────────────────────────────────────────────────────────┘
*/