MESSAGE SESSION:DISPLAY-TIMEZONE SESSION:TIMEZONE NOW.

DEFINE VARIABLE dt  AS DATETIME EXTENT 8 FORMAT "99/99/9999 HH:MM:SS.SSS+HH:MM".
DEFINE VARIABLE et  AS DATETIME EXTENT 8 FORMAT "99/99/9999 HH:MM:SS.SSS      ".
DEFINE VARIABLE dtz AS DATETIME-TZ EXTENT 8 FORMAT "99/99/9999 HH:MM:SS.SSS+HH:MM".
DEFINE VARIABLE etz AS DATETIME-TZ EXTENT 8 FORMAT "99/99/9999 HH:MM:SS.SSS      ".

FORM
"display-timezone = 0" SKIP
"          created = 0                   created = 60" SKIP
"display  " dt[1]  dt[2] SKIP
"   0    z" dtz[1] dtz[2] SKIP
"         " et[1]  et[2] SKIP
"        z" etz[1] etz[2] SKIP " " SKIP
"display  " dt[3]  dt[4] SKIP
"  300   z" dtz[3] dtz[4] SKIP
"         " et[3]  et[4] SKIP
"        z" etz[3] etz[4] SKIP " " SKIP
"display-timezone = 120" SKIP
"          created = 0                   created = 60" SKIP
"display  " dt[5]  dt[6] SKIP
"   0    z" dtz[5] dtz[6] SKIP
"         " et[5]  et[6] SKIP
"        z" etz[5] etz[6] SKIP " " SKIP
"display  " dt[7]  dt[8] SKIP
"  300   z" dtz[7] dtz[8] SKIP
"         " et[7]  et[8] SKIP
"        z" etz[7] etz[8] SKIP WITH NO-LABELS NO-BOX.

SESSION:DISPLAY-TIMEZONE = 0.
MESSAGE SESSION:DISPLAY-TIMEZONE.

SESSION:TIMEZONE = 0.
dt[1]  = NOW.
dtz[1] = NOW.
dt[3]  = NOW.
dtz[3] = NOW.
et[1]  = NOW.
etz[1] = NOW.
et[3]  = NOW.
etz[3] = NOW.
DISPLAY dt[1] dtz[1] et[1] etz[1].

SESSION:TIMEZONE = 300.
dt[2]  = NOW.
dtz[2] = NOW.
dt[4]  = NOW.
dtz[4] = NOW.
et[2]  = NOW.
etz[2] = NOW.
et[4]  = NOW.
etz[4] = NOW.
DISPLAY dt[3] dtz[3] dt[4] dtz[4] et[3] etz[3] et[4] etz[4].

SESSION:TIMEZONE = 0.
DISPLAY dt[2] dtz[2] et[2] etz[2].

SESSION:DISPLAY-TIMEZONE = 120.
MESSAGE SESSION:DISPLAY-TIMEZONE.

SESSION:TIMEZONE = 0.
dt[5]  = NOW.
dtz[5] = NOW.
dt[7]  = NOW.
dtz[7] = NOW.
et[5]  = NOW.
etz[5] = NOW.
et[7]  = NOW.
etz[7] = NOW.
DISPLAY dt[5] dtz[5] et[5] etz[5].

SESSION:TIMEZONE = 300.
dt[6]  = NOW.
dtz[6] = NOW.
dt[8]  = NOW.
dtz[8] = NOW.
et[6]  = NOW.
etz[6] = NOW.
et[8]  = NOW.
etz[8] = NOW.
DISPLAY dt[7] dtz[7] dt[8] dtz[8] et[7] etz[7] et[8] etz[8].

SESSION:TIMEZONE = 0.
DISPLAY dt[6] dtz[6] et[6] etz[6].
/* expected output:
┌─────────────────────────────────────────────────────────────────────┐
│display-timezone = 0                                                 │
│        created = 0                   created = 60                   │
│                                                                     │
│display   29/04/2013 13:20:07.012+01:00 29/04/2013 18:20:07.019+01:00│
│   0    z 29/04/2013 13:20:07.012+00:00 29/04/2013 18:20:07.019+05:00│
│          29/04/2013 13:20:07.012       29/04/2013 18:20:07.019      │
│        z 29/04/2013 13:20:07.012       29/04/2013 13:20:07.019      │
│                                                                     │
│display   29/04/2013 13:20:07.012+01:00 29/04/2013 18:20:07.019+01:00│
│  300   z 29/04/2013 13:20:07.012+00:00 29/04/2013 18:20:07.019+05:00│
│          29/04/2013 13:20:07.012       29/04/2013 18:20:07.019      │
│        z 29/04/2013 13:20:07.012       29/04/2013 13:20:07.019      │
│                                                                     │
│display-timezone = 120                                               │
│        created = 0                   created = 60                   │
│                                                                     │
│display   29/04/2013 13:20:07.023+01:00 29/04/2013 18:20:07.025+01:00│
│   0    z 29/04/2013 13:20:07.023+00:00 29/04/2013 18:20:07.025+05:00│
│          29/04/2013 13:20:07.023       29/04/2013 18:20:07.025      │
│        z 29/04/2013 15:20:07.023       29/04/2013 15:20:07.025      │
│                                                                     │
│display   29/04/2013 13:20:07.023+01:00 29/04/2013 18:20:07.025+01:00│
│  300   z 29/04/2013 13:20:07.023+00:00 29/04/2013 18:20:07.025+05:00│
│          29/04/2013 13:20:07.023       29/04/2013 18:20:07.025      │
│        z 29/04/2013 15:20:07.023       29/04/2013 15:20:07.025      │
└─────────────────────────────────────────────────────────────────────┘*/