SESSION:DATE-FORMAT = "mdy".
DEFINE VARIABLE dt AS DATETIME.
DEFINE VARIABLE dtz1 AS DATETIME-TZ.
DEFINE VARIABLE dtz2 AS DATETIME-TZ.
dt = DATETIME("12-31-2013 12:34:56").
dtz1 = DATETIME-TZ("12-31-2013 12:34:56+10:10").
dtz2 = DATETIME-TZ("12-06-2013 12:34:56+10:10").

SESSION:DISPLAY-TIMEZONE = ?.
DISPLAY SESSION:DISPLAY-TIMEZONE SKIP.
DISPLAY dt + 0 SKIP.
DISPLAY dt + 0 FORMAT "99-99-9999 HH:MM:SS.SSS+HH:MM" SKIP.
DISPLAY dtz1 + 0 SKIP.
DISPLAY dtz1 + 0 FORMAT "99-99-9999 HH:MM:SS.SSS" SKIP.
DISPLAY dtz2 + 0 SKIP.
DISPLAY dtz2 + 0 FORMAT "99-99-9999 HH:MM:SS.SSS" SKIP(1).

SESSION:DISPLAY-TIMEZONE = 300.
DISPLAY SESSION:DISPLAY-TIMEZONE SKIP.
DISPLAY dt + 0 SKIP.
DISPLAY dt + 0 FORMAT "99-99-9999 HH:MM:SS.SSS+HH:MM" SKIP.
DISPLAY dtz1 + 0 SKIP.
DISPLAY dtz1 + 0 FORMAT "99-99-9999 HH:MM:SS.SSS" SKIP.
DISPLAY dtz2 + 0 SKIP.
DISPLAY dtz2 + 0 FORMAT "99-99-9999 HH:MM:SS.SSS".

/* expected output:
┌─────────────────────────────┐
│         ?                   │
│12/31/2013 12:34:56.000      │
│12-31-2013 12:34:56.000+00:00│
│12/31/2013 12:34:56.000+10:10│
│12-31-2013 02:24:56.000      │
│12/06/2013 12:34:56.000+10:10│
│12-06-2013 02:24:56.000      │
│                             │
│       300                   │
│12/31/2013 12:34:56.000      │
│12-31-2013 12:34:56.000+00:00│
│12/31/2013 12:34:56.000+10:10│
│12-31-2013 07:24:56.000      │
│12/06/2013 12:34:56.000+10:10│
│12-06-2013 07:24:56.000      │
└─────────────────────────────┘
*/