/* this code tests 64-bit expressions of indexes */
define temp-table tt
   field i as INT FORMAT ">>>>>>>>>>>"
   field ii as int extent 2 FORMAT ">>>>>>>>>>>"
   field j as INT64 FORMAT ">>>>>>>>>>>"
   field jj as int64 extent 2 FORMAT ">>>>>>>>>>>".

create tt.
assign
   tt.i = 0
   tt.j = 2000000000
   tt.ii[3 mod 2] = 1
   tt.ii[1 + 1] = 2
   tt.jj[3 - 2] = 2000000001
   tt.jj[2 * 1] = 2000000002.

create tt.
ASSIGN 
    tt.i = 2000000000
    tt.j = 2
    tt.ii[0 + 1] = 2000000000
    tt.ii[1 + 1] = 2000000000
    tt.jj[0 + 1] = 3
    tt.jj[0 + 2] = 4.

/*assign
   tt.i = 10 + 1
   tt.j = 20000
   tt.ii[4000000001 - 4000000000] = 10 + 10
   tt.ii[int64(4000000000 / 4000000000) + 1] = 20 + 10
   tt.jj[4000000001 - 4000000000] = 4000000000 + 1
   tt.jj[int64(4000000000 / 4000000000) + 1] = 400000000 + 2.*/

DISPLAY tt WITH SIDE-LABELS.
PAUSE.

FIND FIRST tt WHERE i < 5.
DISPLAY tt WITH SIDE-LABELS.
PAUSE.


FIND LAST tt WHERE ii[1] + ii[2] < 200000000.
DISPLAY tt.
DISPLAY SKIP "A:" tt.i + 0 "S:" ii[1] + ii[2] WITH SIDE-LABELS.

FIND FIRST tt WHERE 
        jj[int64(4000000000 / 4000000000)] > 400000000 * 10 AND 
        ii[2 - 1] < 100000000 * 10000000  AND 
        jj[1 + 1] + jj[2 - 1] > 200000000.
DISPLAY tt WITH SIDE-LABELS.